import java.math.BigInteger;
import java.util.ArrayList;

/**
 * 퓬̕Б̐wc\p[eB̃NXłB
 * @author theki
 *
 */
public class Party {
	// o^t̓o^ԍ
	private int num ;
	// p[eB̌tꗗ
	private ArrayList<Player> member ;
	// o^t̕
	private String entryPlayerString ;
	// p[eB^I[o[L_[Wv
	private BigInteger totalOverKillDamage ;
	// p[eBgpvbVv
	private int totalPush ;
	// o^trhꂽ
	private int entryPlayerBuildCount ;
	
	/**
	 * RXgN^
	 * @param num o^ԍ
	 * @param playerString t
	 */
	public Party( int num, String playerString ){
		// Xe[^X̏
		this.num = num ;
		member = new ArrayList<Player>() ;
		entryPlayerString = playerString ;
		totalOverKillDamage = BigInteger.ZERO ;
		totalPush = 0 ;
		entryPlayerBuildCount = 1 ;
		member.add( new Player(0,entryPlayerString));
	}
	
	/**
	 * o[S̃Xe[^Xo͂܂B
	 */
	public void printPartyStatus(){
		for(int i=0;i<member.size();i++)
			member.get(i).printStatus( false, true );
	}
	
	/**
	 * o[̑SẴANV𖢎gpԂɂ܂B
	 */
	public void resetPartyActions(){
		for(int i=0;i<member.size();i++){
			Player p = member.get(i) ;
			for(int j=0;j<p.getActions().size();j++)
				p.getActions().get(j).setUsed(false);
		}
	}
	
	/**
	 * Sjbgɑ΂ޏꏈs܂B
	 */
	public void checkLeaveParty(){
		for(int i=0;i<member.size();i++){
			Player p = member.get(i);
			if( p.getHp().compareTo(BigInteger.ZERO) <= 0 )
				p.checkLife() ;
			if( p.getHp().compareTo(BigInteger.ZERO) <= 0 ){
				totalPush += p.getPush() ;
				totalOverKillDamage = totalOverKillDamage.add(p.getHp())  ;
				member.remove(p);
				i -- ;
			}
		}
	}
	
	/**
	 * o[ŜAPZbg܂B
	 */
	public void setPartyAp(){
		for(int i=0;i<member.size();i++){
			Player p = member.get(i) ;
			if( p.getSleep() > 0 ){
				p.setSleep( p.getSleep()-1 ) ;
				p.setAp( BigInteger.ZERO ) ;
			}
			else
				p.setAp( p.getSpd() ) ;
		}
	}
	
	/**
	 * sIh̌̏ŏs܂B
	 * @param turn ݂̃^[
	 */
	public void checkPeriod( int turn ){
		for(int i=0;i<member.size();i++){
			Player p = member.get(i) ;
			for(int j=0;j<p.getActions().size();j++){
				Action a = p.getActions().get(j) ;
				if( a.getPeriod() != -1 && a.getPeriod() <= turn ){
					p.getActions().remove(a);
					j--;
				}
			}
		}
	}
	
	// ȉAsetter&getter
	
	public int getNum() {
		return num;
	}
	public void setNum(int num) {
		this.num = num;
	}
	public ArrayList<Player> getMember() {
		return member;
	}
	public void setMember(ArrayList<Player> member) {
		this.member = member;
	}
	public String getEntryPlayerString() {
		return entryPlayerString;
	}
	public void setEntryPlayerString(String entryPlayerString) {
		this.entryPlayerString = entryPlayerString;
	}
	public BigInteger getTotalOverKillDamage() {
		return totalOverKillDamage;
	}
	public void setTotalOverKillDamage(BigInteger totalOverKillDamage) {
		this.totalOverKillDamage = totalOverKillDamage;
	}
	public int getTotalPush() {
		return totalPush;
	}
	public void setTotalPush(int totalPush) {
		this.totalPush = totalPush;
	}
	public int getEntryPlayerBuildCount() {
		return entryPlayerBuildCount;
	}
	public void setEntryPlayerBuildCount(int entryPlayerBuildCount) {
		this.entryPlayerBuildCount = entryPlayerBuildCount;
	}
}
