import java.math.BigInteger;
import java.util.ArrayList;

/**
 * t/jbg\NXłB
 * @author theki
 *
 */
public class Player {
/*
 * UAhA̎ނȂǂۑ
 */
	// t̓o^ԍ
	private int num ;
	// o^̊eXe[^X
	private int baseHp, baseAtk, baseDef, baseSpd ;
	// /őHPAÚAh́AfAMPAAP
	private BigInteger hp, maxHp, atk, def, spd, mp, ap ;
	// ꗗ
	private ArrayList<Action> actions ;
	// ȅ
	private int  poison, stan, guard, reflection, life, soul, shield, barrier ;
	private boolean appeal, heavens ;
	private int sleep, miscarriage, deadly, dodge, cushion ;
	private int drive, flip, push, quick, slow ;
	// t̖O
	private String comment = null ;
	// t̓o^̌̕
	private String actionStr = null ;
	// to^[
	private int appearTurn ;
	// ̃jbg̃p[eB̓o^t
	private String masterStr ;
	// ݂̃^C~Oœssǂ̃tO
	private boolean dualActionFlag ;
	// ݂̃^C~OŎgp錕
	private Action useAction ;
	
	// pubNXg[W
	public static final String[] publicStrage =
	{
		"5/0/0/0//ouA",
		"5/0/0/1/r/EBvX",
		"15/0/0/1/ّ/}gbNX",
		"5/0/0/3/ՏՎ/fXG[i",
		"15/0/4/1/a/@傤",
		"5/0/0/4/ՔMՔM/d",
		"5/3/0/3//SlăI_",
		"5/3/0/2/œ/",
		"40/0/0/1//[N",
		"15/0/1/2/MՐ/pj郉CJ",
		"5/5/0/2//RE",
		"10/0/0/3/MMMd/{gG",
		"15/0/0/3/MMd/]A",
		"10/0/0/4/rr/S",
		"55/0/3/6/ٖٗ}Œx19/SAct.6",
		"10/5/3/2/aa/eI",
		"10/0/0/2/َٖcr/i",
		"30/0/6/4/MaMa/hS"
	};

	/**
	 * RXgN^
	 * @param num@SettingMatchł̃jbg`ԍ
	 * @param unitData@jbg\L
	 */
	public Player(int i, String unitData){
		String[] value = unitData.split("/");
		if( value.length < 3 && value.length > 6 ){
			Util.outputString("KiÕjbgf[^:"+unitData+"\n",SettingMatch.errorFileName);
		}
		// p^[Ȃ
		if( value.length == 4 ){
			PlayerBuilder(i,Integer.parseInt(value[0]),Integer.parseInt(value[1]),
					Integer.parseInt(value[2]),Integer.parseInt(value[3]),"","");
		}
		// OȂ
		else if( value.length == 5 ){
			PlayerBuilder(i,Integer.parseInt(value[0]),Integer.parseInt(value[1]),
					Integer.parseInt(value[2]),Integer.parseInt(value[3]),value[4],"");
		}
		// O
		else if( value.length == 6 ){
			PlayerBuilder(i,Integer.parseInt(value[0]),Integer.parseInt(value[1]),
					Integer.parseInt(value[2]),Integer.parseInt(value[3]),value[4],value[5]);
		}
	}
	
	/**
	 * ̃IuWFNgm100̃jbgɂ܂B
	 * @param num@SettingMatchł̃jbg`ԍ
	 * @param hp@HP
	 * @param atk@U
	 * @param def@h
	 * @param spd@f
	 * @param pattern@sp^[
	 */
	private void PlayerBuilder(int num , int hp, int atk, int def, int spd, String actionStr, String comment){
		this.num = num ;
		this.baseHp = hp ;
		baseAtk = atk ;
		baseDef = def ;
		baseSpd = spd ;
		this.hp = this.maxHp = new BigInteger(hp+"") ;
		this.atk = new BigInteger(atk+"") ;
		this.def = new BigInteger(def+"") ;
		this.ap = this.spd = new BigInteger(spd+"") ;
		this.mp = BigInteger.ZERO ;
		guard = reflection = life = 0 ;
		this.actionStr = actionStr ;
		this.comment = comment ;
		appearTurn = -1 ;
		actions = createActions(actionStr);
		this.masterStr = getEntryString() ;
	}

	/**
	 * 񂩂AActionz𐶐܂B
	 * @param actionStr
	 * @return
	 */
	private ArrayList<Action> createActions(String actionStr){
		if( actionStr == null )
			return new ArrayList<Action>() ;
		// ANVp^[
		ArrayList<Action> entryActions = new ArrayList<Action>() ;
		for(int i=0;i<actionStr.length();i++){ 
			String str = actionStr.substring(i, i+1) ;
			// xNݒ肳Ă΋L
			int boot = 1;
			if( (boot = Util.getNextNum(actionStr, i)) != Integer.MAX_VALUE ){
				i ++ ;
				if( boot != 0 )
					i += (int)Math.log10(boot) ;
				str += boot ;
			}

			// |Z
			if( actionStr.charAt(i) == '*' ){
				int n = Util.getNextNum(actionStr, i) ;
				i += (int)Math.log10(n)+1 ;
				for(int j=0;j<n;j++){
					Action a = new Action(str);
					entryActions.add( a ) ;
				}
			}
			// ANVo^
			else{
				Action a = new Action(str);
				entryActions.add( a ) ;
				// G[ɂƂ肠ʍ
				if( a.getType() == -1 )
					System.out.print("!");
			}
		}
		return entryActions;
	}

	
	/**
	 * {o^t̕Ԃ܂B
	 * @return
	 */
	public String getEntryString(){
		return baseHp+"/"+baseAtk+"/"+baseDef+"/"+baseSpd+"/"+actionStr+"/"+comment ;
	}

	/**
	 * vC[̏Ԃ\܂B
	 * @param numFlag o^ԍo͂邩ǂ
	 * @param commentFlag Oo͂邩ǂ
	 */
	public void printStatus( boolean numFlag, boolean commentFlag){
		// o^ԍ̏o
		if( numFlag ){
			if(num<10)Util.outputString(" " ,SettingMatch.resultFileName);
			Util.outputString("  "+num+": " ,SettingMatch.resultFileName);
		}

		// {Xe[^X
		Util.outputString(hp+"/"+atk+"/"+def+"/"+spd+"/" ,SettingMatch.resultFileName);

		// 
		boolean usedFlag = false ;
		for(int i=0;i<actions.size();i++){
			Action a = getActions().get(i);

			// gpς݂Ȃ[]ł
			if( !a.isUsed() && usedFlag ){
				usedFlag = false ;
				Util.outputString( "]" ,SettingMatch.resultFileName );
			}
			if( a.isUsed() && !usedFlag ){
				usedFlag = true ;
				Util.outputString( "[" ,SettingMatch.resultFileName );
			}
			
			Util.outputString( a.getStates() ,SettingMatch.resultFileName );

			// gpς݂Ȃ[]ł
			if( a.isUsed() && i == actions.size()-1 )
				Util.outputString( "]" ,SettingMatch.resultFileName );
		}

		// Ȍo
		if( commentFlag ){
			if( comment != null)
				Util.outputString("/"+comment ,SettingMatch.resultFileName);
			else
				Util.outputString("/"+num ,SettingMatch.resultFileName);
		}
		
		// e
		if(mp.compareTo(BigInteger.ZERO)!=0||stan>0||sleep>0||deadly>0||poison>0||miscarriage>0
		 ||reflection>0||dodge>0||barrier>0||cushion>0||flip>0||shield>0||guard>0
		 ||soul>0||life>0||push>0||heavens||quick>0||slow>0||drive>0||appeal)
			Util.outputString("/<" ,SettingMatch.resultFileName);
		if(mp.compareTo(BigInteger.ZERO)!=0)Util.outputString("MP"+mp+"," ,SettingMatch.resultFileName);
		if(stan>0)Util.outputString("" ,SettingMatch.resultFileName);
		if(stan>1)Util.outputString("*"+stan+"," ,SettingMatch.resultFileName);
		if(sleep>0)Util.outputString("" ,SettingMatch.resultFileName);
		if(sleep>1)Util.outputString("*"+sleep+"," ,SettingMatch.resultFileName);
		if(deadly>0)Util.outputString("" ,SettingMatch.resultFileName);
		if(deadly>1)Util.outputString("*"+deadly+"," ,SettingMatch.resultFileName);
		if(poison>0)Util.outputString("" ,SettingMatch.resultFileName);
		if(poison>1)Util.outputString("*"+poison+"," ,SettingMatch.resultFileName);
		if(miscarriage>0)Util.outputString("" ,SettingMatch.resultFileName);
		if(miscarriage>1)Util.outputString("*"+miscarriage+"," ,SettingMatch.resultFileName);
		if(reflection>0)Util.outputString("" ,SettingMatch.resultFileName);
		if(reflection>1)Util.outputString("*"+reflection+"," ,SettingMatch.resultFileName);
		if(dodge>0)Util.outputString("" ,SettingMatch.resultFileName);
		if(dodge>1)Util.outputString("*"+dodge+"," ,SettingMatch.resultFileName);
		if(barrier>0)Util.outputString("" ,SettingMatch.resultFileName);
		if(barrier>1)Util.outputString("*"+barrier+"," ,SettingMatch.resultFileName);
		if(cushion>0)Util.outputString("" ,SettingMatch.resultFileName);
		if(cushion>1)Util.outputString("*"+cushion+"," ,SettingMatch.resultFileName);
		if(flip>0)Util.outputString("e" ,SettingMatch.resultFileName);
		if(flip>1)Util.outputString("*"+flip+"," ,SettingMatch.resultFileName);
		if(shield>0)Util.outputString("|" ,SettingMatch.resultFileName);
		if(shield>1)Util.outputString("*"+shield+"," ,SettingMatch.resultFileName);
		if(guard>0)Util.outputString("" ,SettingMatch.resultFileName);
		if(guard>1)Util.outputString("*"+guard+"," ,SettingMatch.resultFileName);
		if(soul>0)Util.outputString("" ,SettingMatch.resultFileName);
		if(soul>1)Util.outputString("*"+soul+"," ,SettingMatch.resultFileName);
		if(life>0)Util.outputString("" ,SettingMatch.resultFileName);
		if(life>1)Util.outputString("*"+life+"," ,SettingMatch.resultFileName);
		if(push>0)Util.outputString("" ,SettingMatch.resultFileName);
		if(push>1)Util.outputString("*"+push+"," ,SettingMatch.resultFileName);
		if(heavens)Util.outputString("V" ,SettingMatch.resultFileName);
		if(quick>0)Util.outputString("}" ,SettingMatch.resultFileName);
		if(quick>1)Util.outputString("*"+quick+"," ,SettingMatch.resultFileName);
		if(slow>0)Util.outputString("" ,SettingMatch.resultFileName);
		if(slow>1)Util.outputString("*"+slow+"," ,SettingMatch.resultFileName);
		if(drive>0)Util.outputString("" ,SettingMatch.resultFileName);
		if(drive>1)Util.outputString("*"+drive+"," ,SettingMatch.resultFileName);
		if(appeal)Util.outputString("" ,SettingMatch.resultFileName);
		if(mp.compareTo(BigInteger.ZERO)!=0||stan>0||sleep>0||deadly>0||poison>0||miscarriage>0
		 ||reflection>0||dodge>0||barrier>0||cushion>0||flip>0||shield>0||guard>0
		 ||soul>0||life>0||push>0||heavens||quick>0||slow>0||drive>0||appeal)
			Util.outputString(">" ,SettingMatch.resultFileName);
		
		Util.outputString("\n" ,SettingMatch.resultFileName);
	
	}
	
	/**
	 * ɎgANVT܂B
	 * @param turn
	 */
	public int searchNextAction( int turn ){
		for(int select=0;select<actions.size();select++){
			Action a = actions.get(select);
			// typeK؂ŁAgpŁAMPƒxNvȂ
			if( a.getType() != -1 && a.isUsed() == false
			 && BigInteger.valueOf(a.getMp()).compareTo(this.mp) <= 0
			 && a.getBoot() <= turn )
					return select ;
		}
		return -1 ;
	}
	
	/**
	 * _[W󂯂܂BSꍇACtE\E܂B
	 * @param d _[W
	 * @param turn ݂̃^[
	 */
	public void damage( BigInteger d, int turn ){
		BigInteger damage = d ;
		
		if( damage.compareTo(BigInteger.ZERO) <= 0 ) return ;
		Util.outputString( "      --"+damage+"_̃_[WI  " ,SettingMatch.resultFileName);
		hp = hp.subtract(damage) ;
		printStatus(false, true);
		
		// SĂ\Ȃ烉Ct\E
		if( turn > 0 )
			checkLife();
	}
	
	/**
	 * Ct̔܂BԂHP1̃Ct-1܂B
	 */
	public void checkLife(){
		if( getHp().compareTo(BigInteger.ZERO) <= 0 && getSoul() > 0 ){
			setHp(getMaxHp()) ;
			Util.outputString("    --"+getComment()+" \EB@" ,SettingMatch.resultFileName);
			addSoul(-1) ;
			//@őHP0Ȃ\ESď
			if( getHp().compareTo(BigInteger.ZERO) == 0 )
				setSoul(0);
			printStatus(false, false);
		}
		if( getHp().compareTo(BigInteger.ZERO) <= 0 && getLife() > 0 ){
			setHp(BigInteger.ONE) ;
			Util.outputString("    --"+getComment()+" CtB@" ,SettingMatch.resultFileName);
			addLife(-1) ;
			printStatus(false, false);
		}
	}

	/**
	 * HPS񕜂܂B
	 * @param turn
	 */
	public void healLife( int turn ) {
		Util.outputString("    --"+getComment()+"HP͑S񕜂B" ,SettingMatch.resultFileName);
		this.hp = this.maxHp;
		printStatus(false, false);
		// őHP0ƑȂ̂
		if( turn != 0 )
			checkLife();
	}
	
	/**
	 * ̃^C~OœssȂ΁AɎgpANVIAۑ܂B
	 * @param maxSpd ̃^C~Oœt̑f
	 * @param maxQuick ̃^C~Oœt̃NCbN
	 * @param turn ݂̃^[
	 * @param myParty ̃p[eB
	 * @param enemyParty ΐ푊̃p[eB
	 * @return ɎgpANV/X^݂ȂꍇAfalseԂAȊȌꍇtrueԂ܂B
	 */
	public boolean setUseAction( BigInteger maxSpd, int maxQuick, int turn, Party myParty, Party enemyParty ){
		dualActionFlag = false ;
		useAction = null ;
		
		// APAő̃jbgȂ
		if( ap.compareTo(BigInteger.ZERO) > 0 && spd.compareTo(maxSpd) == 0 && quick-slow == maxQuick ){
			Util.outputString("  --"+comment+", cAP:"+ap ,SettingMatch.resultFileName);
			ap = ap.subtract(BigInteger.ONE) ;
			// X^̏ꍇ
			if( stan > 0 ){
				Util.outputString("(X^I)\n" ,SettingMatch.resultFileName);
				stan -- ;
				return true ;
			}
			// gꍇ
			else{
				Util.outputString("\n" ,SettingMatch.resultFileName);
				int select = -1 ;
				// ɎgT[`
				if( (select = searchNextAction(turn)) != -1 ){
					Action action = actions.get( select ) ;
					// RXg̎x
					action.setUsed(true);
					if( action.getMp() != Integer.MIN_VALUE )
						mp = mp.subtract(BigInteger.valueOf(action.getMp())) ;
					// ANVۑ,Ώۂ̃ANV
					dualActionFlag = true ;
					useAction = action ;
					action.setTargetAction( null );
					if( actions.size() > select+1
					 && ( action.getGenre() == Action.ADD || action.getGenre() == Action.CTR ))
						action.setTargetAction( actions.get(select+1) );
					// ~ebhɂ
					if( action.isLimited() )
						actions.remove(action);

					// Ώیť
					if( action.getGenre() == Action.ATK )
						action.setTargetPlayers(searchTargetList(enemyParty.getMember(),true,action.isWhole())) ;
					else if( action.getGenre() == Action.SPT ){
						if( action.isWhole() )
							action.setTargetPlayers(searchTargetList(myParty.getMember(),false,action.isWhole())) ;
						else{
							ArrayList<Player> players = new ArrayList<Player>(1);
							players.add(this);
							action.setTargetPlayers(players);
						}
					}
					return true ;
				}
			}
		}
		return false ;
	}

	/**
	 * partyAΏۂƂȂvC[ListԂ܂B
	 * @param party
	 * @param atkFlag@UANVij
	 * @param wholeFlag@ANVɑS̉t^Ă邩
	 * @return
	 */
	private ArrayList<Player> searchTargetList( ArrayList<Player> party, boolean atkFlag, boolean wholeFlag) {
		ArrayList<Player> targets = new ArrayList<Player>() ;
		// S̉̏ꍇ
		if( wholeFlag ){
			for(int i=0;i<party.size();i++)
				targets.add(party.get(i)) ;
		}
		// S̉Ȃ
		else{
			int target = 0 ;
			// Ȁꍇ
			if( atkFlag ){
				// jbgT
				for(int i=0;i<party.size();i++){
					if( party.get(i).isAppeal() ){
						target = i ;
						break ;
					}
				}
			}
			if( party.size() > target )
				targets.add(party.get(target));
		}
		
		return targets ;
	}


	public int getNum() {
		return this.num ;
	}
	public String getComment() {
		if(comment!=null)
			return comment;
		return "player:"+num ;
	}
	public void setComment(String comment) {
		this.comment = comment ;
	}
	public BigInteger getMaxHp() {
		return maxHp;
	}
	public void setMaxHp( BigInteger maxHp ) {
		this.maxHp = maxHp ;
	}
	public int getBaseHp() {
		return baseHp;
	}

	public void setBaseHp(int baseHp) {
		this.baseHp = baseHp;
	}

	public int getBaseAtk() {
		return baseAtk;
	}

	public int getBaseDef() {
		return baseDef;
	}

	public int getBaseSpd() {
		return baseSpd;
	}

	public BigInteger getMp() {
		return mp;
	}
	public void setMp(BigInteger mp) {
		this.mp = mp;
	}
	public void addMp(BigInteger mp) {
		this.mp = this.mp.add(mp);
	}

	public BigInteger getHp() {
		return hp;
	}
	public void setHp(BigInteger hp) {
		this.hp = hp;
	}
	public BigInteger getAtk() {
		return atk;
	}
	public void setAtk(BigInteger atk) {
		this.atk = atk;
	}
	public void addAtk(BigInteger atk) {
		this.atk = this.atk.add(atk);
		if( this.atk.compareTo(BigInteger.ZERO) < 0 )
			this.atk = BigInteger.ZERO ;
	}
	public BigInteger getDef() {
		return def;
	}
	public void setDef(BigInteger def) {
		this.def = def;
	}
	public void addDef(BigInteger def) {
		this.def = this.def.add(def);
		if( this.def.compareTo(BigInteger.ZERO) < 0 )
			this.def = BigInteger.ZERO ;
	}
	public BigInteger getSpd() {
		return spd;
	}
	public void setSpd(BigInteger spd) {
		this.spd = spd;
	}
	public void addSpd(BigInteger spd) {
		this.spd = this.spd.add(spd);
	}
	public int getPoison() {
		return poison;
	}
	public void setPoison(int set) {
		this.poison = set ;
	}
	public void addPoison(int add) {
		this.poison += add ;
	}
	public int getStan() {
		return stan;
	}
	public void setStan(int set) {
		this.stan = set ;
	}
	public void addStan(int add) {
		this.stan += add ;
	}
	public int getGuard() {
		return guard;
	}
	public void addGuard(int add) {
		this.guard += add ;
	}
	public int getReflection() {
		return reflection;
	}
	public void setReflection(int reflection) {
		this.reflection = reflection ;
	}
	public void addReflection(int add) {
		this.reflection += add ;
	}
	public int getLife() {
		return life;
	}
	public void addLife(int add) {
		this.life += add ;
	}
	public int getSoul() {
		return soul;
	}

	public void setSoul(int soul) {
		this.soul = soul;
	}
	public void addSoul(int add) {
		this.soul += add ;
	}

	public boolean isAppeal() {
		return appeal;
	}

	public void setAppeal(boolean appeal) {
		this.appeal = appeal;
	}
	public ArrayList<Action> getActions() {
		return actions;
	}
	public void setActions(ArrayList<Action> actions) {
		this.actions = actions;
	}
	public String getActionStr() {
		return actionStr;
	}
	public void setActionStr(String actionStr) {
		this.actionStr = actionStr;
	}
	public int getAppearTurn() {
		return appearTurn;
	}
	public void setAppearTurn(int appearTurn) {
		this.appearTurn = appearTurn;
	}

	public String getMasterStr() {
		return masterStr;
	}
	public void setMasterStr(String masterStr) {
		this.masterStr = masterStr;
	}

	public BigInteger getAp() {
		return ap;
	}

	public void setAp(BigInteger ap) {
		this.ap = ap;
	}

	public int getShield() {
		return shield;
	}
	public void setShield(int shield) {
		this.shield = shield;
	}
	public void addShield(int add) {
		this.shield += add;
	}

	public int getBarrier() {
		return barrier;
	}
	public void setBarrier(int barrier) {
		this.barrier = barrier;
	}
	public void addBarrier(int add) {
		this.barrier += add;
	}

	public boolean isHeavens() {
		return heavens;
	}
	public void setHeavens(boolean heavens) {
		this.heavens = heavens;
	}

	public int getSleep() {
		return sleep;
	}
	public void setSleep(int sleep) {
		this.sleep = sleep;
	}
	public void addSleep(int sleep) {
		this.sleep += sleep;
	}

	public int getMiscarriage() {
		return miscarriage;
	}
	public void setMiscarriage(int miscarriage) {
		this.miscarriage = miscarriage;
	}
	public void addMiscarriage(int miscarriage) {
		this.miscarriage += miscarriage;
	}

	public int getDeadly() {
		return deadly;
	}
	public void setDeadly(int deadly) {
		this.deadly = deadly;
	}
	public void addDeadly(int deadly) {
		this.deadly += deadly;
	}

	public int getDodge() {
		return dodge;
	}
	public void setDodge(int dodge) {
		this.dodge = dodge;
	}
	public void addDodge(int dodge) {
		this.dodge += dodge;
	}

	public int getCushion() {
		return cushion;
	}
	public void setCushion(int cushion) {
		this.cushion = cushion;
	}
	public void addCushion(int cushion) {
		this.cushion += cushion;
	}

	public int getDrive() {
		return drive;
	}
	public void setDrive(int drive) {
		this.drive = drive;
	}
	public void addDrive(int drive) {
		this.drive += drive;
	}

	public int getFlip() {
		return flip;
	}
	public void setFlip(int flip) {
		this.flip = flip;
	}
	public void addFlip(int flip) {
		this.flip += flip;
	}

	public int getPush() {
		return push;
	}
	public void setPush(int push) {
		this.push = push;
	}
	public void addPush(int push) {
		this.push += push;
	}

	public int getQuick() {
		return quick;
	}
	public void setQuick(int quick) {
		this.quick = quick;
	}
	public void addQuick(int quick) {
		this.quick += quick;
	}

	public int getSlow() {
		return slow;
	}
	public void setSlow(int slow) {
		this.slow = slow;
	}
	public void addSlow(int slow) {
		this.slow += slow;
	}

	public boolean isDualActionFlag() {
		return dualActionFlag;
	}

	public void setDualActionFlag(boolean dualActionFlag) {
		this.dualActionFlag = dualActionFlag;
	}

	public Action getUseAction() {
		return useAction;
	}

	public void setUseAction(Action useAction) {
		this.useAction = useAction;
	}

}