import java.io.BufferedReader;
import java.io.FileReader;
import java.math.BigInteger;
import java.util.ArrayList;

/**
 * 퓬s߂̃x[XNXłB
 * @author theki
 */
public class SettingMatch {
	// ^ÕO[v
	protected ArrayList<Group> groups = new ArrayList<Group>() ;
	// ݂̃^[
	private int turn = 0 ;
	// ڍׂȏo͂邩ǂ
	protected boolean fileOutFlag = true ;
	// ꂼ̃jbg̃rhsꂽ
	public static int[] buildCount = new int[2+Player.publicStrage.length];
	// 퓬ʂ̏o͗pt@C
	public static final String resultFileName = "result.txt";
	// G[Ȍo͗pt@C
	public static final String errorFileName = "errorLog.txt";

	/**
	 * RXgN^
	 * fileName𖼑OƂt@C茕tꗗ荞݁Agroups𐶐܂B
	 * @param fileName
	 * @throws Exception
	 */
	public SettingMatch( String fileName ) throws Exception {
		
		BufferedReader fin  = new BufferedReader(new FileReader(fileName));
		String data;	// t@C͕
		String groupName = "" ;	// ݂̃^O
		while((data = fin.readLine()) != null){			
			// RgAEg[h
			if( data.startsWith("/") || data.endsWith("-") )
				continue ;
			
			// ^Ot[h
			else if( data.startsWith("[") && data.endsWith("]") )
				groupName = data.replaceFirst("\\[", "").replaceFirst("\\]", "");
			
			// ^Ot[h
			else if( data.lastIndexOf("/") < data.lastIndexOf("[") && data.endsWith("]") )
				AddPlayerInGroup(data.substring(0, data.lastIndexOf("[")), data.substring(data.lastIndexOf("[")+1,data.length()-1));
			
			// ^OȂt[h
			else
				AddPlayerInGroup(data, groupName);			
		}
	}
	
	/**
	 * groupName𖼑OƂgroupɁAdataɋLq錕tǉ܂B
	 * groupNameɑΉgroupȂꍇAV쐬܂B
	 * @param data t
	 * @param groupName O[v
	 */
	private void AddPlayerInGroup( String data, String groupName ){
		// groupNameɑΉgroup΁AgroupɃjbgǉ
		for(int i=0;i<groups.size();i++){
			if( groupName.equalsIgnoreCase(groups.get(i).getName()) ){
				groups.get(i).getPlayers().add( new Player(groups.get(i).getPlayers().size(), data ));
				return ;
			}
		}
		// ΉgroupȂ΁AVgroup𐶐ăjbgǉ
		groups.add( new Group(groupName) ) ;
		groups.get(groups.size()-1).getPlayers().add( new Player( 0, data ) ) ;
	}

	/**
	 * og̑gݍ킹⏟s\̕\Ȃǂs܂B
	 * @throws Exception 
	 */
	public void exec(){
	}
	
	/**
	 * Player a  Player b ̃oǧʂԂ܂B
	 * Ȃ-1AȁȂ1,b̏Ȃ2Ԃ܂B
	 * @param a
	 * @param b
	 */
	protected int battle( Player a, Player b ){
		turn = 0 ;
		// ҂̃jbgXg
		Party aParty = new Party( a.getNum(), a.getEntryString() ) ;
		Party bParty = new Party( b.getNum(), b.getEntryString() ) ;
		
		// rhꂽ񐔂
		buildCount = new int[2+Player.publicStrage.length];
		buildCount[0] = buildCount[1] = 1 ;
		int judgeResult = 0 ;	// s

		// ^[̐퓬
		while( turn <= 20 ){
			
			// 𖢎gpԂɂ
			aParty.resetPartyActions();
			bParty.resetPartyActions();

			// ^[Jn
			Util.outputString("--turn:"+turn+"\n" ,resultFileName );
			Util.outputString("--"+a.getComment()+"'s party\n" ,resultFileName );
			aParty.printPartyStatus();
			Util.outputString("--"+b.getComment()+"'s party\n" ,resultFileName );
			bParty.printPartyStatus();
			
			// 1^[ڊJn̎S
			if( turn == 1 && ( judgeResult = checkJudge( aParty, bParty, turn ) ) != 0 ){
				Util.outputString("\n  --B\n" ,resultFileName );
				return judgeResult ;
			}

			// Ŕ
			checkPoison( aParty, bParty ) ;

			// ŎS
			if( ( judgeResult = checkJudge( aParty, bParty, turn ) ) != 0 ){
				Util.outputString("\n  --B\n" ,resultFileName );
				return judgeResult ;
			}

			// APZbg
			aParty.setPartyAp();
			bParty.setPartyAp();
			
			// sl郆jbgƁAgp錕
			boolean turnEndFlag = entitleAct( aParty, bParty ) ;
			while( !turnEndFlag ){

				// s
				for(int i=0;i<=Action.ENV;i++)
					processingDualAction( i, aParty, bParty );

				// s
				if( ( judgeResult = checkJudge( aParty, bParty, turn ) ) != 0 ){
					Util.outputString("\n  --B\n" ,resultFileName );
					return judgeResult ;
				}
				
				// ɓssjbgƁAgp錕
				turnEndFlag = entitleAct( aParty, bParty );

			}
			// sIh̌̏
			aParty.checkPeriod( turn ) ;
			bParty.checkPeriod( turn ) ;
			turn ++ ;
			Util.outputString("\n" ,resultFileName );
		}
		Util.outputString("  --I^[łB\n" ,resultFileName );

		return checkJudge( aParty, bParty, turn );
	}
	
	/**
	 * 2̃p[eBAssjbg1̂擾AԂ܂B
	 * @param genre ̎s
	 * @param a
	 * @param b
	 * @return [p[eBa̓stAp[eBb̓st]
	 *         stȂꍇ͌t̑nulli[
	 */
	private Player[] getDualActionPlayers( int genre, Party a, Party b ){
		Player[] result = {null,null};
		for(int i=0;i<a.getMember().size();i++){
			if( a.getMember().size() > i ){
				Player p = a.getMember().get(i);
				if( p.isDualActionFlag() && p.getUseAction().getGenre() == genre ){
					p.setDualActionFlag(false);
					result[0] = p ;
					break ;
				}
			}
		}
		for(int i=0;i<b.getMember().size();i++){
			if( b.getMember().size() > i ){
				Player p = b.getMember().get(i);
				if( p.isDualActionFlag() && p.getUseAction().getGenre() == genre ){
					p.setDualActionFlag(false);
					result[1] = p ;
					break ;
				}
			}
		}
		return result ;

	}
	
	/**
	 * ss܂B
	 * @param genre ̎s
	 * @param aParty
	 * @param bParty
	 */
	private void processingDualAction( int genre, Party aParty, Party bParty ){
		final int SPT = 0, CTR = 1, ADD = 2, ATK = 3, BLD = 4, ENV = 5 ;
		Player[] dualActionPlayers = getDualActionPlayers( genre, aParty, bParty ) ;
		Player ap = dualActionPlayers[0] ;
		Player bp = dualActionPlayers[1] ;
		
		// s
		while( ap != null || bp != null ){
			Action aa = null ;	// 1̎gpANV
			Action ba = null ;	// 2̎gpANV

			// ΏۂƂȂ郆jbg𒊏o
			ArrayList<Player> aTargetList = new ArrayList<Player>() ;
			ArrayList<Player> bTargetList = new ArrayList<Player>() ;
			if( ap != null ){
				aa = ap.getUseAction() ;
				if( genre == SPT || genre == ATK )
					aTargetList = aa.getTargetPlayers() ;
			}
			if( bp != null ){
				ba = bp.getUseAction() ;
				if( genre == SPT || genre == ATK )
					bTargetList = ba.getTargetPlayers() ;
			}
			
			// s
			if( aa != null && ba != null ){
				Util.outputString("    --sB\n" ,resultFileName );
				Util.outputString("    --"+ap.getComment()+"́@"+Action.NAME[aa.getType()]+"I \n" ,resultFileName );
				Util.outputString("    --"+bp.getComment()+"́@"+Action.NAME[ba.getType()]+"I \n" ,resultFileName );

				// ߂^[QbgȂiU/⏕ȊOjȂ
				if( aTargetList.size() == 0 && bTargetList.size() == 0  ){
					// 
					if( genre == CTR ){
						aa.execControl(ap);
						ba.execControl(bp);
					}
					// rh{
					else if( genre == ENV || genre == BLD ){
						turn = aa.execBuildAndEnv(ap, aParty, bParty, turn);
						turn = ba.execBuildAndEnv(bp, bParty, aParty, turn);
					}
					// ǉ
					else if( genre == ADD ){
						Action aAdd = aa.execAdd(ap,bParty) ;
						Action bAdd = ba.execAdd(bp,aParty) ;
						if( aAdd != null )
							ap.getActions().add(aAdd) ;
						if( bAdd != null )
							bp.getActions().add(bAdd) ;
					}
				}
				
				// U/⏕ȂAǂ^[QbgȂȂ܂
				while( aTargetList.size() > 0 || bTargetList.size() > 0 ){
					// ^[QbgȂs
					Player at = null ;
					Player bt = null ;
					if( aTargetList.size() > 0 ){
						at = aTargetList.get(0);
						aTargetList.remove(at);
					}
					if( bTargetList.size() > 0 ){
						bt = bTargetList.get(0);
						bTargetList.remove(bt);
					}
					
					// Ả񐔂JԂ
					boolean aFlag = false ;
					boolean bFlag = false ;
					if( at != null )
						aFlag = true ;
					if( bt != null )
						bFlag = true ;
					for(int hit=0; aFlag || bFlag ;hit++){

						// Ȕꍇ͔ˏl
						if( genre == ATK ){
							if( aFlag && bFlag ){
								// s̔
								Player[] p = checkReflection(ap, at, bp, bt, 0, aa.isIgnoreMirror(), ba.isIgnoreMirror());
								
								// s̔
								if( p[4] == null )
									superSuperDualAction(aa,ba,p[0],p[1],p[2],p[3],turn);
								// aɍsB
								else if( p[4].equals(ap) ){
									processingAttack(p[0], p[1], aa);
									processingAttack(p[2], p[3], ba);
								}
								// aɍsB
								else{
									processingAttack(p[2], p[3], ba);
									processingAttack(p[0], p[1], aa);
								}
							}
							// UEЕ̂
							else if( aFlag )
								processingAttack(ap, checkReflection(ap, at, aa.isIgnoreMirror() ), aa);
							else if( bFlag )
								processingAttack(bp, checkReflection(bp, bt, ba.isIgnoreMirror() ), ba);

						// ⏕ȂΔˍlȂ
						} else {
							if( aFlag )
								aa.execSupport(ap,at, turn);
							if( bFlag )
								ba.execSupport(bp,bt, turn);
						}
						
						// ŘAIȂAtO
						if( hit+1 == aa.getHit() ) aFlag = false ;
						if( hit+1 == ba.getHit() ) bFlag = false ;
					}
					
				}

			// Pƍs
			} else if( aa != null || ba != null ) {
				// Kvȃf[^u
				ArrayList<Player> targetList ;
				Party party ;
				Party eParty ;
				Player p,t ;
				Action a = null ;
				if( ap != null ){
					p = ap ;
					targetList = aTargetList ;
					a = aa ;
					party = aParty ;
					eParty = bParty ;
				}
				else{
					p = bp ;
					targetList = bTargetList ;
					a = ba ;
					party = bParty ;
					eParty = aParty ;
				}
				Util.outputString("    --"+p.getComment()+"́@"+Action.NAME[a.getType()]+"I \n" ,resultFileName );

				// ߂^[QbgȂiU/⏕ȊOjȂ
				if( targetList.size() == 0 ){
					// 
					if( genre == CTR )
						a.execControl(p);
					else if( genre == ADD ){
						Action add = a.execAdd(p, eParty);
						if( add != null )
							p.getActions().add(add);
					}
						
					// rh{
					else if( genre == ENV || genre == BLD )
						turn = a.execBuildAndEnv(p, party, eParty, turn);
				}
				
				// ǂ^[QbgȂȂ܂
				while( targetList.size() > 0 ){
					t = targetList.get(0);
					targetList.remove(t);
					
					// Ả񐔂JԂ
					for(int hit=0; hit < a.getHit() ;hit++){
						// Ȕꍇ͔ˏ
						if( genre == ATK ){
							processingAttack(p, checkReflection(p, t, a.isIgnoreMirror() ), a);
						} else {
							a.execSupport(p,t, turn) ;
						}
						
					}
					
				}
				
				// ^[20߂Ă̏
				if( turn > 20 )
					return ;
			}
			if( aa != null ){
				ap.getUseAction().secondEffect(ap,aa,turn);
			}
			if( ba != null ){
				bp.getUseAction().secondEffect(bp,ba,turn);
			}
			
			// s郆jbgXV
			dualActionPlayers = getDualActionPlayers( genre, aParty, bParty ) ;
			ap = dualActionPlayers[0] ;
			bp = dualActionPlayers[1] ;


		}
	}

	/**
	 * ˌʂ܂񂾁AȔs܂B
	 * @param a st
	 * @param t UΏیt
	 * @param action U
	 */
	private void processingAttack( Player a, Player t, Action action ){

		BigInteger damage ; 

		// 𔻒
		if( t.getDodge() > 0 && !action.isIgnoreMirror() ){
			t.addDodge(-1);
			Util.outputString("    --"+t.getComment()+",؂Bc:"+t.getDodge()+" \n" ,resultFileName );
			return ;
		}

		damage = action.execAttack(a,t, turn) ;
		if( action.getType() != Action.MAFU )
			t.damage( damage, turn );
		action.additionEffect(a,t,action,damage,turn);
		Action rob = action.optionEffect(a,t,damage,turn);
		// 
		if( rob != null ){
			t.getActions().remove(rob);
			a.getActions().add(rob);
			Util.outputString("      --"+a.getComment()+""+Action.NAME[rob.getType()]+"B\n" ,SettingMatch.resultFileName);
		}
	}
	
	/**
	 * s̏s܂BapataaAbpbtbbg܂B
	 * ؂̏܂B
	 * @param aa p[eBa̎s錕
	 * @param ba p[eBb̎s錕
	 * @param ap p[eBa̍st
	 * @param at p[eBa̍sΏیt
	 * @param bp p[eBa̍st
	 * @param bt p[eBb̍sΏیt
	 * @param turn 
	 */
	protected void superSuperDualAction(Action aa, Action ba, Player ap, Player at,
			Player bp, Player bt, int turn) {
		boolean aDodgeFlag = false ;
		boolean bDodgeFlag = false ;
		Action aRob = null ;
		Action bRob = null ;
		// ؂菈
		if( at.getDodge() > 0 && !aa.isIgnoreMirror() ){
			at.addDodge(-1);
			Util.outputString("    --"+at.getComment()+",؂Bc:"+at.getDodge()+" \n" ,resultFileName );
			aDodgeFlag = true ;
		}
		if( bt.getDodge() > 0 && !ba.isIgnoreMirror() ){
			bt.addDodge(-1);
			Util.outputString("    --"+bt.getComment()+",؂Bc:"+bt.getDodge()+" \n" ,resultFileName );
			bDodgeFlag = true ;
		}
		
		// ǂ؂Ȃꍇ
		if( !aDodgeFlag && !bDodgeFlag ){
			BigInteger aDamage = aa.execAttack(ap,at,turn) ;
			BigInteger bDamage = ba.execAttack(bp,bt,turn) ;
			if( aa.getType() != Action.MAFU )
				at.damage( aDamage, turn );
			if( ba.getType() != Action.MAFU )
				bt.damage( bDamage, turn );
			
			aa.additionEffect(ap,at,ba,aDamage,turn);
			ba.additionEffect(bp,bt,aa,bDamage,turn);
			aRob = aa.optionEffect(ap,at,aDamage,turn);
			bRob = ba.optionEffect(bp,bt,bDamage,turn);
		}
		// Б؂ꍇ
		else if( !aDodgeFlag ){
			BigInteger aDamage = aa.execAttack(ap,at, turn) ;
			if( aa.getType() != Action.MAFU )
				at.damage( aDamage, turn );
			aa.additionEffect(ap,at,ba,aDamage,turn);
			aRob = aa.optionEffect(ap,at,aDamage,turn);
		}
		else if( !bDodgeFlag ){
			BigInteger bDamage = ba.execAttack(bp,bt, turn) ;
			if( ba.getType() != Action.MAFU )
				bt.damage( bDamage, turn );
			ba.additionEffect(bp,bt,aa,bDamage,turn);
			bRob = ba.optionEffect(bp,bt,bDamage,turn);
		}
		
		// 
		if( aRob != null ){
			at.getActions().remove(aRob);
			ap.getActions().add(aRob);
			Util.outputString("      --"+at.getComment()+""+Action.NAME[aRob.getType()]+"B\n" ,SettingMatch.resultFileName);
		}
		if( bRob != null ){
			bt.getActions().remove(bRob);
			bp.getActions().add(bRob);
			Util.outputString("      --"+bt.getComment()+""+Action.NAME[bRob.getType()]+"B\n" ,SettingMatch.resultFileName);
		}
	}

	/**
	 * Player aatAbbt̊Ԃ̓sɂ锽ˏ܂B
	 * @param a p[eBa̍st
	 * @param at p[eBa̍sΏیt
	 * @param b p[eBa̍st
	 * @param bt p[eBa̍sΏیt
	 * @return [a,a̔ˌ̑Ώ,b,b̔ˌ̑Ώ,ɍsvC[(a or b or null)]
	 *         ɍsvC[null̏ꍇ͒s
	 */
	protected Player[] checkReflection( Player a, Player at, Player b, Player bt, int tempo, boolean aMirrorFlag, boolean bMirrorFlag ){
		Player[] result = {a, at, b, bt, null} ;
		boolean aReflag = false ;
		boolean bReflag = false ;
		// at
		if( at.getReflection() > 0 && !aMirrorFlag ){
			at.addReflection(-1) ;
			Util.outputString("    --"+at.getComment()+"@˔B@ˁF"+at.getReflection()+"\n" ,resultFileName );
			aReflag = true ;
		}
		// bt
		if( bt.getReflection() > 0 && !bMirrorFlag ){
			bt.addReflection(-1) ;
			Util.outputString("    --"+bt.getComment()+"@˔B@ˁF"+bt.getReflection()+"\n" ,resultFileName );
			bReflag = true ;
		}
		
		// ǂ˂Ȃ瑱s
		if( aReflag && bReflag )
			return checkReflection( at, a, bt, b, tempo+1, aMirrorFlag, bMirrorFlag );
		// Е
		else if( aReflag ^ bReflag ){
			// ̔˂ȂAΏۂ͎s
			if( (tempo%2) == 1 ){
				result[2] = bt ;
				result[0] = at ;
			}
			if( aReflag ){
				result[1] = checkReflection(at,a,aMirrorFlag);
				result[4] = b ;
			}
			if( bReflag ){
				result[3] = checkReflection(bt,b,bMirrorFlag);
				result[4] = a ;
			}
			return result;
		}
		// ǂ˂ȂȂΒs
		else {
			// ˂Ŋ񂾂ꍇAsҁΏ
			if( (tempo%2) == 1 ){
				result[0] = result[1] ;
				result[2] = result[3] ;
			}
			return result;
		}
	}
	
	/**
	 * Player aat̊Ԃ̔˂܂B
	 * @param a st
	 * @param at sΏیt
	 * @return ŏIIȑΏۂƂȂPlayer
	 */
	protected Player checkReflection( Player a, Player at, boolean mirrorFlag ){
		Player result = at ;
		if( at.getReflection()>0 && !mirrorFlag ){
			at.addReflection(-1) ;
			Util.outputString("    --"+at.getComment()+"@˔B@ˁF"+at.getReflection()+"\n" ,resultFileName );
			return checkReflection( at, a, mirrorFlag  ) ;
		}
		else
			return result ;
	}

	/**
	 * SޏꔻAyтɏss܂B
	 * @param a
	 * @param b
	 * @return sĂȂȂ0AȂ-1AȁȂ1Ab̏Ȃ2
	 */
	protected int checkJudge( Party a, Party b, int turn ){
		// 0^[ڂɏs͂Ȃ
		if( turn < 1 )
			return 0 ;
		
		// Sޏꔻ
		a.checkLeaveParty() ;
		b.checkLeaveParty() ;
		
		boolean aFlag = true ;
		boolean bFlag = true ;
		ArrayList<Player> aParty = a.getMember() ;
		ArrayList<Player> bParty = b.getMember() ;
		
		// StOitrueȂSŁj
		if( aParty.size() != 0 )
			aFlag = false ;
		if( bParty.size() != 0 )
			bFlag = false ;

		// ݂Ȃ瑱sor^[I[o[ȂvbVHP
		if( !aFlag && !bFlag ){
			if( turn <= 20 )
				return 0 ;
			
			// vbVHP菈
			int aPush , bPush ;
			BigInteger aHp , bHp ;
			aPush = bPush = 0 ;
			aHp = bHp = BigInteger.ZERO ;
			
			for(int i=0;i<aParty.size();i++)
				aPush += aParty.get(i).getPush() ;
			for(int i=0;i<bParty.size();i++)
				bPush += bParty.get(i).getPush() ;
			for(int i=0;i<aParty.size();i++)
				aHp = aHp.add(aParty.get(i).getHp()) ;
			for(int i=0;i<bParty.size();i++)
				bHp = bHp.add(bParty.get(i).getHp()) ;
			Util.outputString("  --F@<vbV>F"+aPush+"@- "+bPush+", HP:"+aHp+" - "+bHp+"\n" ,resultFileName );

			if( aPush < bPush ) return 2 ;
			else if( aPush > bPush ) return 1 ;
			else if( aHp.compareTo(bHp) < 0 ) return 2 ;
			else if( aHp.compareTo(bHp) > 0 ) return 1 ;
			else return -1 ;
		}
		
		// ЕȂΐ퓬I
		else if( aFlag && !bFlag ) return 2 ;
		else if( bFlag && !aFlag ) return 1 ;

		
		// Sł̏ꍇ̏
		else{
			Util.outputString("  --F@<vbV>F"+a.getTotalPush()+"@- "+b.getTotalPush()+", HP:"+a.getTotalOverKillDamage()+" - "+b.getTotalOverKillDamage()+"\n" ,resultFileName );
			if( a.getTotalPush() < b.getTotalPush() ) return 2 ;
			else if( a.getTotalPush() > b.getTotalPush() ) return 1 ;
			else if( a.getTotalOverKillDamage().compareTo( b.getTotalOverKillDamage() ) < 0 ) return 2 ;
			else if( a.getTotalOverKillDamage().compareTo( b.getTotalOverKillDamage() ) > 0 ) return 1 ;
			else return -1 ;
		}
		
	}
	

	/**
	 * SẴjbgɑ΂āAŃ_[W^܂B
	 * @param a p[eB1
	 * @param b p[eB2
	 */
	protected void checkPoison( Party a, Party b ){
		ArrayList<Player> aMember = a.getMember() ;
		ArrayList<Player> bMember = b.getMember() ;
		
		// NŏԂł邩ǂ`FbN
		boolean flag = false ;
		for(int i=0;i<aMember.size();i++){
			if( flag ) break ;
			if( aMember.get(i).getPoison() > 0 || aMember.get(i).getDeadly() > 0  )
				flag = true ;
		}
		for(int i=0;i<bMember.size();i++){
			if( flag ) break ;
			if( bMember.get(i).getPoison() > 0 || bMember.get(i).getDeadly() > 0 )
				flag = true ;
		}
		
		// NłȂSɑ΂ēŏ
		if( flag ){
			Util.outputString("  --ŔB\n" ,resultFileName );
			for(int i=0;i<aMember.size();i++){
				if( aMember.get(i).getDeadly() > 0 )
					aMember.get(i).addPoison( aMember.get(i).getDeadly() ) ;
				if( aMember.get(i).getPoison() > 0 )
					aMember.get(i).damage( BigInteger.valueOf(aMember.get(i).getPoison()), turn ) ;
			}
			for(int i=0;i<bMember.size();i++){
				if( bMember.get(i).getDeadly() > 0 )
					bMember.get(i).addPoison( bMember.get(i).getDeadly() ) ;
				if( bMember.get(i).getPoison() > 0 )
					bMember.get(i).damage( BigInteger.valueOf(bMember.get(i).getPoison()), turn ) ;
			}
		}
	}

	/**
	 * partỹjbgɍs^܂B
	 * ̍ۂɁAsŎgpANVۑ܂B
	 * @param a
	 * @param b
	 */
	private boolean entitleAct( Party a, Party b ){
		ArrayList<Player> aMember = a.getMember() ;
		ArrayList<Player> bMember = b.getMember() ;
		int maxQuick = Integer.MIN_VALUE ;

		// SAP0ȂA^[I
		boolean endFlag = true ;
		for(int i=0;i<aMember.size();i++){
			if( aMember.get(i).getAp().compareTo(BigInteger.ZERO) > 0 )
				endFlag = false ;
		}
		for(int i=0;i<bMember.size();i++){
			if( bMember.get(i).getAp().compareTo(BigInteger.ZERO) > 0 )
				endFlag = false ;
		}
		if( endFlag )
			return true ;
		
		// s郆jbgI
		// NCbN-X[Af̍ől擾
		BigInteger maxSpd = BigInteger.ZERO ;
		for(int i=0;i<aMember.size();i++){
			Player p = aMember.get(i);
			if( p.getAp().compareTo(BigInteger.ZERO) > 0 ){
				if( p.getQuick()-p.getSlow() > maxQuick ){
					maxQuick = p.getQuick()-p.getSlow() ;
					maxSpd = p.getSpd() ;
				}
				else if( p.getQuick()-p.getSlow() == maxQuick && maxSpd.compareTo(p.getSpd()) < 0 )
					maxSpd = p.getSpd() ;
			}
		}
		for(int i=0;i<bMember.size();i++){
			Player p = bMember.get(i);
			if( p.getAp().compareTo(BigInteger.ZERO) > 0 ){
				if( p.getQuick()-p.getSlow() > maxQuick ){
					maxQuick = p.getQuick()-p.getSlow() ;
					maxSpd = p.getSpd() ;
				}
				else if( p.getQuick()-p.getSlow() == maxQuick && maxSpd.compareTo(p.getSpd()) < 0 )
					maxSpd = p.getSpd() ;
			}
		}

		Util.outputString("\n" ,SettingMatch.resultFileName);
		// gp錕̑I
		boolean flag = false ;
		for(int i=0;i<aMember.size();i++)
			flag |= aMember.get(i).setUseAction(maxSpd, maxQuick, turn,a,b);
		for(int i=0;i<bMember.size();i++)
			flag |= bMember.get(i).setUseAction(maxSpd, maxQuick, turn,b,a);
		
		// NglȂAP0
		if( !flag ){
			for(int i=0;i<aMember.size();i++){
				Player p = aMember.get(i) ;
				if( p.getSpd().compareTo(maxSpd) == 0 && p.getQuick()-p.getSlow() == maxQuick )
					p.setAp(BigInteger.ZERO);
			}
			for(int i=0;i<bMember.size();i++){
				Player p = bMember.get(i) ;
				if( p.getSpd().compareTo(maxSpd) == 0 && p.getQuick()-p.getSlow() == maxQuick )
					p.setAp(BigInteger.ZERO);
			}
			Util.outputString("  --g錕ȂB\n" ,SettingMatch.resultFileName);
		}
		
		return false ;

	}


	// 퓬ʂt@Co͂܂B
	protected void outputResult() throws Exception{
	}
}
