import java.util.HashMap;

/**
 * sNXłB
 * @author theki
 *
 */
public class RoundRobin extends SettingMatch{
	// \o͂t@C
	protected static final String ResultTableFileName = "RoundRobin" ;

	/**
	 * RXgN^
	 */
	public RoundRobin( String fileName ) throws Exception{
		super(fileName);
		Util.outputString("\n================ result ===============\n\n" ,resultFileName);

	}
	
	/**
	 * og̑gݍ킹⏟s\̕\Ȃǂs܂B
	 */
	public void exec() {

		for(int i=0;i<groups.size();i++){
			// 퓬stO[v
			Group aGroup = groups.get(i);

			// ^Ȍ(^OmŐ퓬
			if( aGroup.getName().equalsIgnoreCase("") ){
				// \
				int[][] result = new int[aGroup.getPlayers().size()][aGroup.getPlayers().size()];
				for(int k=0;k<aGroup.getPlayers().size();k++){
					for(int l=0;l<aGroup.getPlayers().size();l++){
						// Lΐ/ɏς݂̕
						if( k == l )
							result[k][l] = -1 ;
						else if( k > l ){
							if( result[l][k] == 1 )
								result[k][l] = 2 ;
							else if( result[l][k] == 2 )
								result[k][l] = 1 ;
							else
								result[k][l] = -1 ;
						}
						// 퓬
						else
							result[k][l] = execMatch(aGroup,k,aGroup,l);
					}
				}
				// ʂL^
				HashMap<String,int[][]> groupResult = aGroup.getResults() ;
				groupResult.put("", result);				
				aGroup.setResults( groupResult );
			}

			// ʏ̏
			for(int j=i+1;j<groups.size();j++){
				// ΐ푊̃O[v
				Group bGroup = groups.get(j);
				// ȏ\
				int[][] aResult = new int[aGroup.getPlayers().size()][bGroup.getPlayers().size()];
				int[][] bResult = new int[bGroup.getPlayers().size()][aGroup.getPlayers().size()];

				for(int k=0;k<aGroup.getPlayers().size();k++){
					for(int l=0;l<bGroup.getPlayers().size();l++){
						// ΐ{ȏ\𓯎ɍXV
						aResult[k][l] = execMatch(aGroup,k,bGroup,l);
						if( aResult[k][l] == 1 )
							bResult[l][k] = 2 ;
						else if( aResult[k][l] == 2 )
							bResult[l][k] = 1 ;
						else
							bResult[l][k] = -1 ;
					}
				}
				//@ʂۑ
				HashMap<String,int[][]> groupResult = aGroup.getResults() ;
				groupResult.put(bGroup.getName(), aResult);				
				aGroup.setResults( groupResult );
				groupResult = bGroup.getResults() ;
				groupResult.put(aGroup.getName(), bResult);				
				bGroup.setResults( groupResult );
			}
		}

		// Text,CSVɌʂo
		outputTextResultInAllPlayer();
		outputCsvResultInAllPlayer();
		// t@Co
		Util.saveData() ;
	}
	
	/**
	 * agaNumԖڂɂ錕tƁAbgbNumԖڂɂ錕t킹܂B
	 * @param ag
	 * @param aNum
	 * @param bg
	 * @param bNum
	 * @return agaNumȂ1AbgbNumȂ2AȂ-1
	 */
	protected int execMatch( Group ag, int aNum, Group bg, int bNum ){
		int result ;
		// t2l𒊏o
		Player a = ag.getPlayers().get(aNum);
		Player b = bg.getPlayers().get(bNum);
		// 퓬Oo
		Util.outputString("zzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz\n" ,resultFileName );
		Util.outputString(""+a.getComment()+"@VS@"+b.getComment()+"["+aNum+"@"+ag.getName()+"vs"+bNum+"@"+bg.getName()+"]\n" ,resultFileName );
		// 퓬
		result = battle( a,b );
		// 퓬o
		Util.outputString(""+a.getComment()+"@VS@"+b.getComment() ,resultFileName);
		if( result==1 )
			Util.outputString(" -> "+a.getComment()+" B\n" ,resultFileName);
		else if( result==2 )
			Util.outputString(" -> "+b.getComment()+" B\n" ,resultFileName);
		else Util.outputString("B\n" ,resultFileName);
		Util.outputString("\n" ,resultFileName);

		return result ;
	}

	/**
	 * groups̒AOnamełgroupԂ܂B
	 * @param name
	 * @return
	 */
	private Group getGroupByName(String name){
		for(int i=0;i<groups.size();i++)
			if( groups.get(i).getName().equalsIgnoreCase(name))
				return groups.get(i);
		
		return null ;
	}
	
	/**
	 * St̑\txto͂܂B
	 */
	protected void outputTextResultInAllPlayer() {
		String outFileName = ResultTableFileName+".txt";
		Util.outputString("RESULT\n" ,outFileName);

		// O[v̈ꗗ擾
		Group[] resultGroups = new Group[groups.size()];
		for(int i=0;i<groups.size();i++)
			resultGroups[i] = getGroupByName(groups.get(i).getName());
		
		// ߂ɑSt̃XybN\i܂Ƃ߃^O
		int playerNum = 0 ;
		for(int i=0;i<resultGroups.length;i++){
			Group group = resultGroups[i];
			if( i != 0 || ! group.getName().equalsIgnoreCase("") )
				Util.outputString("["+group.getName()+"]\n" ,outFileName ) ;
			for(int j=0;j<group.getPlayers().size();j++){
				Player p = group.getPlayers().get(j) ;
				if(playerNum<100)Util.outputString(" " ,outFileName);
				if(playerNum<10)Util.outputString(" " ,outFileName);
				Util.outputString("  "+playerNum+": " ,outFileName);
				Util.outputString(p.getEntryString()+"\n" ,outFileName ) ;
				playerNum ++ ;
			}
		}

		// ԍ
		Util.outputString("zzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzzz\n    " ,outFileName);
		for(int i=0;i<playerNum;i++){
			if(i<100) Util.outputString(" " ,outFileName);
			if(i<10) Util.outputString(" " ,outFileName);
			Util.outputString(i+"" ,outFileName);
		}
		Util.outputString("\n" ,outFileName);

		// f[^
		int nowPlayerNum = 0 ;
		for(int i=0;i<resultGroups.length;i++){
			Group ag = resultGroups[i];
			// eso
			for(int j=0;j<ag.getPlayers().size();j++){
				int win=0, draw=0, lose=0 ;
				if(nowPlayerNum<100) Util.outputString(" " ,outFileName);
				if(nowPlayerNum<10) Util.outputString(" " ,outFileName);
				Util.outputString(" "+nowPlayerNum ,outFileName);
				
				// o͑Ώۂ̊eO[v
				for(int k=0;k<resultGroups.length;k++){
					Group bg = resultGroups[k];
				
					int[][] result = ag.getResults().get(bg.getName());
					// ^O
					if( result == null ){
						for(int l=0;l<bg.getPlayers().size();l++)
							Util.outputString("   " ,outFileName);
					}
					else {
						// o͑ΏۃO[v̊et
						for(int m=0;m<result[j].length;m++){
							if(result[j][m] == 1 ){
								Util.outputString(" @@" ,outFileName);
								win ++ ;
							}
							else if(result[j][m] == 2 ){
								Util.outputString(" . " ,outFileName);
								lose ++ ;
							}
							else{
								Util.outputString(" ++" ,outFileName);
								draw ++ ;
							}
						}
					}
				}
				// Ə
				Util.outputString(" "+win+"-"+draw+"-"+lose+", "+((double)win/(win+draw+lose))+"\n" ,outFileName);
				nowPlayerNum ++ ;
			}
		}
	}

	/**
	 * St̑̌ʂcsvo͂܂B
	 */
	protected void outputCsvResultInAllPlayer() {
	
		String outFileName = ResultTableFileName+".csv";
		Util.outputString("RESULT,,,,,,," ,outFileName);

		// O[v̈ꗗ擾
		Group[] resultGroups = new Group[groups.size()];
		for(int i=0;i<groups.size();i++){
			resultGroups[i] = getGroupByName(groups.get(i).getName());
			// ^Oʂ̐擪
			if( resultGroups[i].getName().equalsIgnoreCase("") ){
				Group temp = resultGroups[i] ;
				resultGroups[i] = resultGroups[0] ;
				resultGroups[0] = temp ;
			}
		}

		// 1sځF^OJ
		int playerNum = 0 ;
		for(int i=0;i<resultGroups.length;i++){
			Group group = resultGroups[i] ;
			Util.outputString(group.getName() ,outFileName);
			for(int j=0;j<group.getPlayers().size();j++){
				Util.outputString("," ,outFileName);
				playerNum ++ ;
			}
		}
		Util.outputString("\n" ,outFileName);
		
		// 2sځFOJ
		Util.outputString(",,,,,,," ,outFileName);
		for(int i=0;i<resultGroups.length;i++){
			Group group = resultGroups[i] ;
			for(int j=0;j<group.getPlayers().size();j++)
				Util.outputString(group.getPlayers().get(j).getEntryString()+"," ,outFileName ) ;
		}
		
		// 3sځFږJ
		Util.outputString("\nHP,U,h,,,O,ԍ," ,outFileName);
		for(int i=0;i<playerNum;i++)
			Util.outputString(i+"," ,outFileName);
		Util.outputString(",,,\n" ,outFileName);
		
		// ȉAt̃f[^
		int pNum = 0 ;
		for(int i=0;i<resultGroups.length;i++){
			Group group = resultGroups[i] ;
			for(int j=0;j<group.getPlayers().size();j++){
				Player p = group.getPlayers().get(j);
				Util.outputString(p.getHp()+","+p.getAtk()+","+ p.getDef()+","+p.getSpd()+
						",\""+p.getActionStr()+"\","+p.getComment()+","+pNum+",",outFileName);
				pNum ++ ;
				
				int win=0,lose=0,draw=0;				
				// o͑Ώۂ̊eO[v
				for(int k=0;k<resultGroups.length;k++){
					Group outputGroup = resultGroups[k];
				
					int[][] result = group.getResults().get(outputGroup.getName());
					// ^O͏o͂Ȃ
					if( result == null ){
						for(int l=0;l<outputGroup.getPlayers().size();l++)
							Util.outputString("," ,outFileName);
					}
					else {
						// o͑ΏۃO[v̌to
						for(int m=0;m<result[j].length;m++){
							if(result[j][m] == 1 ){
								Util.outputString("@," ,outFileName);
								win ++ ;
							}
							else if(result[j][m] == 2 ){
								Util.outputString(".," ,outFileName);
								lose ++ ;
							}
							else{
								Util.outputString("+," ,outFileName);
								draw ++ ;
							}
						}
					}
				}
				// A
				Util.outputString(win+","+draw+","+lose+","+((double)win/(win+draw+lose))+"\n" ,outFileName);
			}
		}
	}


}
